#include <windows.h>
#include <stdio.h>
#include <errno.h>
#include <process.h>
#include <math.h>
#include "stdio.h"
#include "stdlib.h"
#include "ctype.h"
#include "string.h"
#include "resource.h"
#define TEN_K 10240
#define STRMAX 1024
#define MAX_BUFF 128
HWND hMDlgComPortMonitor;
int icom=1;
char start_up=1;
char use_existing_settings;
HANDLE hEndComPortEvent;
int BaudRate=2400;
int ByteSize=8;
int Parity=NOPARITY; // EVENPARITY // ODDPARITY
#define SHOW_PROGRESS
void UpdateComPortDialog(void);
void AddEvent(char *szEvent);
void AddError(char *szcaption)
{
	LPVOID lpMsgBuf;

	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |  FORMAT_MESSAGE_FROM_SYSTEM |  FORMAT_MESSAGE_IGNORE_INSERTS
															,NULL,    GetLastError(),    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
														(LPSTR) &lpMsgBuf,    0,    NULL 
														);
 AddEvent(szcaption);
 AddEvent(lpMsgBuf);
	LocalFree( lpMsgBuf );
 SetLastError(0);
}
/************************************************

Overview:

 hCom = CreateFile(..)
starts file input / output to the com port

Then you set the members of a structure called dcb in the lines such as
  dcb.BaudRate = 2400 ;

Then you call

  bPortReady = SetCommState(hCom, &dcb);

Similarly you do the time outs by setting the fields of a structure
CommTimeouts

Again the fields for this one need to be got right too.

and then call
  bPortReady = GetCommTimeouts (hCom, &CommTimeouts);

Then there is a bit more overhead, then you go into a loop calling
     if (WaitCommEvent(hCom, &dwEvtMask, &overlapped)) 
each time, and the data is actually read in the line

       BOOL bRead = ReadFile(hCom, &szData[iBytesRead],&overlapped)

then a bit more overhead for the loop.

then when all is done, call
 CloseHandle(hCom);


**********************************************/


void AddEvent(char *szEvent)
{
 int iposwas=0;
 char szEvents[TEN_K];
 {
  GetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_COM,szEvents,TEN_K);
  szEvents[TEN_K-1]='\0';
  iposwas=strlen(szEvents);
  if(iposwas>TEN_K-(int)strlen(szEvent))
  {iposwas=TEN_K/2;
   for(;iposwas>=0;iposwas--)
    if(szEvents[iposwas]=='\n')
    {iposwas--;break;}
   szEvents[iposwas]='\0';
  }
  strcat(szEvents,"\r\n");
  strcat(szEvents,szEvent);
 }
 SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_COM,szEvents);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_EDIT_COM),EM_SETSEL
            ,strlen(szEvents),strlen(szEvents)
            );
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_EDIT_COM),EM_SCROLLCARET,0,0);
}

#ifdef SHOW_PROGRESS
void MonitorComPort(void *pvoid)
{
 HANDLE   hCom=0;
 BOOL     bPortReady=0;
 DCB      dcb;
 COMMTIMEOUTS CommTimeouts;
 OVERLAPPED overlapped;
 BOOL fSuccess=0;
 DWORD dwEvtMask=0;
 int nEvents=0;
 int ii=0;
 char szmsg[STRMAX];
 char szCom[STRMAX];
 sprintf(szCom,"com%d",icom);
 memset(&dcb,0,sizeof(DCB));
 if(hEndComPortEvent)
 {
  SetEvent(hEndComPortEvent);
  Sleep(200);
  {
   int ii=0;
   for(ii=0;ii<20;ii++)
   {
    Sleep(50);
    if(hEndComPortEvent==0)
     break;
   }
  }
  if(hEndComPortEvent)
   // couldn't close the thread
   return;
 }
 sprintf(szmsg,"Opening com port %d",icom);
 AddEvent(szmsg);
 hCom = CreateFile
  (szCom
		 ,GENERIC_READ // | GENERIC_WRITE,
		 ,0, // exclusive access
		 NULL, // no security
		 OPEN_EXISTING,
		 FILE_FLAG_OVERLAPPED, // overlapped I/O
		 NULL  // null template 
  );
 if(GetLastError()) 
  AddError("CreateFile:");
 if(hCom==INVALID_HANDLE_VALUE)
 {
  char szText[1024];
  int ierr=0;
  sprintf(szmsg,"Couldn't open the com port %d.",icom
         );
  AddEvent(szmsg);
  if(ierr=GetLastError()) 
   AddError("CreateFile:");
  sprintf(szText,"Couldn't open the com port %d.\n\n%s%s"
         ,icom
         ,ierr==5?"":szmsg
         ,ierr==5
         ?"This probably means that another program is using it or you have another copy of this program running."
         :""
         );
  MessageBox( NULL, (LPCTSTR)szText
         , "Couldn't open Com port", MB_OK | MB_ICONINFORMATION 
         );
  return;
 }
 if(!hEndComPortEvent)
  hEndComPortEvent = CreateEvent
  (
   NULL,   // no security attributes 
   TRUE,  // auto reset event 
   FALSE,  // not signaled 
   NULL    // no name 
   );
 if(GetLastError()) 
  AddError("CreateEvent:");
 AddEvent("Opened com port successfully!");
 memset(&dcb,0,sizeof(dcb));
 dcb.DCBlength=sizeof(dcb);
 bPortReady = SetupComm(hCom, MAX_BUFF, MAX_BUFF); // set buffer sizes
 if(GetLastError()) 
  AddError("SetupComm:");
 bPortReady = GetCommState(hCom, &dcb);
 if(GetLastError()) 
  AddError("GetCommState:");
 // Set all the parameters in the dcb structure that you need to
 // set - if you want to use the existing values, don't need to do anything
 // here.
 if(use_existing_settings)
 {
 	Parity=dcb.Parity;
		BaudRate=dcb.BaudRate;
		ByteSize=dcb.ByteSize;
  UpdateComPortDialog();
 }
 else
 {
  dcb.DCBlength = sizeof ( DCB ) ;
  dcb.BaudRate        = BaudRate;
  dcb.ByteSize        = (BYTE) ByteSize;// number of bits/byte, 4-8
  dcb.Parity=Parity;
  dcb.fParity=Parity==NOPARITY?0:1;
  dcb.StopBits = ONESTOPBIT;    // options are 0,1,2 = 1, 1.5, 2 - this is a matter of the amplitude of the stop bit signal
                                // which is why you have fractional values
  dcb.fOutxCtsFlow    = 0;
  dcb.fOutxDsrFlow    = 0;
  dcb.fDtrControl     = DTR_CONTROL_DISABLE;
  dcb.fDsrSensitivity = 0;
  dcb.fRtsControl     = RTS_CONTROL_DISABLE;
  dcb.fOutX           = 0;
  dcb.fInX            = 0;
  dcb.fErrorChar      = 0;
  dcb.fBinary         = 1;
  dcb.fNull           = 0;
  dcb.fAbortOnError   = 0;
  dcb.wReserved       = 0;
  dcb.XonLim          = 2;
  dcb.XoffLim         = 4;
  dcb.XonChar         = 0x13;
  dcb.XoffChar        = 0x19;
  dcb.EvtChar         = 0;
 }
 bPortReady = SetCommState(hCom, &dcb);
 if(GetLastError()) 
  AddError("SetCommState:");
 // Now do the time outs - use MAXDWORD if unsure
 bPortReady = GetCommTimeouts(hCom, &CommTimeouts);
 CommTimeouts.ReadIntervalTimeout = MAXDWORD;//100;
 CommTimeouts.ReadTotalTimeoutConstant = 0;//100;
 CommTimeouts.ReadTotalTimeoutMultiplier =0;// 50;
 CommTimeouts.WriteTotalTimeoutConstant = 0;//100;
 CommTimeouts.WriteTotalTimeoutMultiplier = 0;//50;
 bPortReady = SetCommTimeouts(hCom, &CommTimeouts);
 // Make an overlapped structure for i.o.
 memset(&overlapped,0,sizeof(overlapped));
  overlapped.hEvent = CreateEvent(
   NULL,   // no security attributes 
   TRUE,  // auto reset event 
   FALSE,  // not signaled 
   NULL    // no name 
   );
 if(GetLastError()) 
  AddError("CreateEvent:");
 // Set the mask for the events you want to listen for
 fSuccess = SetCommMask
  (hCom,EV_RXCHAR | EV_RXFLAG);
 if(!fSuccess)
 {
  AddError("SetCommMask:");
 }
 else
 {
  DWORD dwError=0;
  COMSTAT comState;
  HANDLE hArray[2];
  hArray[0]=overlapped.hEvent;
  hArray[1]=hEndComPortEvent;
  AddEvent("Com Port initialised successfully");
  ClearCommError(hCom,&dwError,&comState); 
  if(GetLastError()) 
   AddError("ClearCommError:");
  AddEvent("Wait");
  // If all is well, go into a loop looking for data

  // Now here the thing is that we read the data as overlapped.
  // So WaitCommEvent will return immediately - and set the
  // handle in its overlapped structure when data arrives.
  for(;;)
  {
   int iBytesRead=0;
   char szData[MAX_BUFF];
   int read_loops=0,read_loops_since_data=0;
   if(GetLastError()) 
    AddError("ResetEvent(overlapped.hEvent):");
   if (WaitCommEvent(hCom, &dwEvtMask,&overlapped)) 
    ;
   else
   if(GetLastError()) 
    AddError("WaitCommEvent:");
   ClearCommError(hCom,&dwError,&comState); 
   if(GetLastError()) 
    AddError("ClearCommError:");
   switch(WaitForMultipleObjects(2,hArray,FALSE, INFINITE))
   {
    case WAIT_OBJECT_0:// input pending - this is the first of the array
                       // entries, i.e. overlapped.hEvent
     ResetEvent(hArray[0]);// reset the event to not signalled
     break;
    case WAIT_OBJECT_0+1:// this is the one to end the thread
     ResetEvent(hArray[1]);
     sprintf(szmsg,"Close request for Com port %d",icom);
     AddEvent(szmsg);
     goto end_thread;
    case WAIT_FAILED:;
     if(GetLastError()) 
      AddError("WaitForMultipleObjects WAIT_FAILED:");
   }
   if(GetLastError()) 
    AddError("WaitForMultipleObjects:");
   ResetEvent(overlapped.hEvent);
   if(GetLastError()) 
    AddError("ResetEvent(overlapped.hEvent):");
   for(;;)
   {
    int iBytesReadThisTime=0;
    int iBytesWas=iBytesRead;
    BOOL bRead;
    bRead= ReadFile(hCom, &szData[iBytesRead], MAX_BUFF-iBytesRead-1, &iBytesReadThisTime,&overlapped);
    iBytesRead+=iBytesReadThisTime;
    if(bRead==FALSE&&GetLastError()==ERROR_IO_PENDING)
    {
     Sleep(2);
     read_loops++;
     continue;
    }
    else
    // we have got it all now
     break;
   }
   szData[iBytesRead]='\0';
   if(szData[0]!='\0')
   {
    AddEvent("Data Received:");
    AddEvent(szData);
    SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_COM_EVENT,szData);
    nEvents++;
    sprintf(szmsg,"%d",nEvents);
    SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_COM_NEVENTS,szmsg);
   }
  }
 }
 end_thread:;
 sprintf(szmsg,"Closing com port %d");
 AddEvent(szmsg);
 PurgeComm(hCom,PURGE_RXABORT|PURGE_RXCLEAR|PURGE_TXCLEAR|PURGE_TXABORT);
 if(GetLastError()) 
  AddError("PurgeComm(hCom)");
 if(hCom)
  CloseHandle(hCom);
 hCom=0;
 if(GetLastError()) 
  AddError("CloseHandle(hCom)");
 if(hEndComPortEvent)
  CloseHandle(hEndComPortEvent);
 hEndComPortEvent=0;
 if(GetLastError()) 
  AddError("CloseHandle(hEndComPortEvent)");
 sprintf(szmsg,"Com port closed");
 AddEvent(szmsg);
 AddEvent("  ");
}

#else

void MonitorComPort(void *pvoid)
{
 // minimal version with no error reporting or indications of
 // progress apart from data received.
 HANDLE   hCom=0;
 BOOL     bPortReady=0;
 DCB      dcb;
 COMMTIMEOUTS CommTimeouts;
 OVERLAPPED overlapped;
 BOOL fSuccess=0;
 DWORD dwEvtMask=0;
 int nEvents=0;
 int ii=0;
 char szCom[STRMAX];
 char szmsg[STRMAX];
 sprintf(szCom,"com%d",icom);
 memset(&dcb,0,sizeof(DCB));
 if(hEndComPortEvent)
 {
  SetEvent(hEndComPortEvent);
  Sleep(200);
  {
   int ii=0;
   for(ii=0;ii<20;ii++)
   {
    Sleep(50);
    if(hEndComPortEvent==0)
     break;
   }
  }
  if(hEndComPortEvent)
   // couldn't close the thread
   return;
 }
 hCom = CreateFile
  (szCom
		 ,GENERIC_READ // | GENERIC_WRITE,
		 ,0, // exclusive access
		 NULL, // no security
		 OPEN_EXISTING,
		 FILE_FLAG_OVERLAPPED, // overlapped I/O
		 NULL  // null template 
  );
 if(hCom==INVALID_HANDLE_VALUE)
 {
  sprintf(szmsg,"Couldn't open Com port %d",icom);
  AddEvent(szmsg);
  return;
 }
 if(!hEndComPortEvent)
  hEndComPortEvent = CreateEvent
  (
   NULL,   // no security attributes 
   TRUE,  // auto reset event 
   FALSE,  // not signaled 
   NULL    // no name 
   );
 memset(&dcb,0,sizeof(dcb));
 dcb.DCBlength=sizeof(dcb);
 SetupComm(hCom, MAX_BUFF, MAX_BUFF); // set buffer sizes
 GetCommState(hCom, &dcb);
 // Set all the parameters in the dcb structure that you need to
 // set - if you want to use the existing values, don't need to do anything
 // here.
 if(use_existing_settings)
 {
		Parity=dcb.Parity;
		BaudRate=dcb.BaudRate;
		ByteSize=dcb.ByteSize;
  UpdateComPortDialog();
 }
 else
 {
  dcb.DCBlength = sizeof ( DCB ) ;
  dcb.BaudRate        = BaudRate;
  dcb.ByteSize        = (BYTE) ByteSize;// number of bits/byte, 4-8
  dcb.Parity=Parity;
  dcb.fParity=Parity==NOPARITY?0:1;
  dcb.StopBits = ONESTOPBIT;    // options are 0,1,2 = 1, 1.5, 2 - this is a matter of the amplitude of the stop bit signal
                                // which is why you have fractional values
  dcb.fOutxCtsFlow    = 0;
  dcb.fOutxDsrFlow    = 0;
  dcb.fDtrControl     = DTR_CONTROL_DISABLE;
  dcb.fDsrSensitivity = 0;
  dcb.fRtsControl     = RTS_CONTROL_DISABLE;
  dcb.fOutX           = 0;
  dcb.fInX            = 0;
  dcb.fErrorChar      = 0;
  dcb.fBinary         = 1;
  dcb.fNull           = 0;
  dcb.fAbortOnError   = 0;
  dcb.wReserved       = 0;
  dcb.XonLim          = 2;
  dcb.XoffLim         = 4;
  dcb.XonChar         = 0x13;
  dcb.XoffChar        = 0x19;
  dcb.EvtChar         = 0;
 }
 SetCommState(hCom, &dcb);
 // Now do the time outs - use MAXDWORD if unsure
 GetCommTimeouts(hCom, &CommTimeouts);
 CommTimeouts.ReadIntervalTimeout = MAXDWORD;//100;
 CommTimeouts.ReadTotalTimeoutConstant = 0;//100;
 CommTimeouts.ReadTotalTimeoutMultiplier =0;// 50;
 CommTimeouts.WriteTotalTimeoutConstant = 0;//100;
 CommTimeouts.WriteTotalTimeoutMultiplier = 0;//50;
 bPortReady = SetCommTimeouts(hCom, &CommTimeouts);
 // Make an overlapped structure for i.o.
 memset(&overlapped,0,sizeof(overlapped));
  overlapped.hEvent = CreateEvent(
   NULL,   // no security attributes 
   TRUE,  // auto reset event 
   FALSE,  // not signaled 
   NULL    // no name 
   );
 // Set the mask for the events you want to listen for
 fSuccess = SetCommMask
  (hCom,EV_RXCHAR | EV_RXFLAG);
 if(fSuccess)
 {
  HANDLE hArray[2];
  DWORD dwError=0;
  COMSTAT comState;
  hArray[0]=overlapped.hEvent;
  hArray[1]=hEndComPortEvent;
  ClearCommError(hCom,&dwError,&comState); 
  sprintf(szmsg,"Com port %d opened and initialised successfully",icom);
  AddEvent(szmsg);
  // If all is well, go into a loop looking for data

  // Now here the thing is that we read the data as overlapped.
  // So WaitCommEvent will return immediately - and set the
  // handle in its overlapped structure when data arrives.
  for(;;)
  {
   int iBytesRead=0;
   char szData[MAX_BUFF];
   int read_loops=0,read_loops_since_data=0;
   WaitCommEvent(hCom, &dwEvtMask,&overlapped);
   ClearCommError(hCom,&dwError,&comState); 
   switch(WaitForMultipleObjects(2,hArray,FALSE, INFINITE))
   {
    case WAIT_OBJECT_0:// input pending - this is the first of the array
                       // entries, i.e. overlapped.hEvent
     ResetEvent(hArray[0]);// reset the event to not signalled
     break;
    case WAIT_OBJECT_0+1:// this is the one to end the thread
     ResetEvent(hArray[1]);
     sprintf(szmsg,"Close request for Com port %d",icom);
     AddEvent(szmsg);
     goto end_thread;
    case WAIT_FAILED:;
   }
   for(;;)
   {
    int iBytesReadThisTime=0;
    int iBytesWas=iBytesRead;
    BOOL bRead;
    bRead= ReadFile(hCom, &szData[iBytesRead], MAX_BUFF-iBytesRead-1, &iBytesReadThisTime,&overlapped);
    iBytesRead+=iBytesReadThisTime;
    if(bRead==FALSE&&GetLastError()==ERROR_IO_PENDING)
    {
     Sleep(2);
     read_loops++;
     continue;
    }
    else
    // we have got it all now
     break;
   }
   szData[iBytesRead]='\0';
   if(szData[0]!='\0')
   {
    AddEvent("Data Received:");
    AddEvent(szData);
    SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_COM_EVENT,szData);
    nEvents++;
    sprintf(szmsg,"%d",nEvents);
    SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_COM_NEVENTS,szmsg);
   }
  }
 }
 end_thread:;
 if(hCom)
 {
  PurgeComm(hCom,PURGE_RXABORT|PURGE_RXCLEAR|PURGE_TXCLEAR|PURGE_TXABORT);
  CloseHandle(hCom);
  hCom=0;
 }
 if(hEndComPortEvent)
  CloseHandle(hEndComPortEvent);
 hEndComPortEvent=0;
 sprintf(szmsg,"Closed Com port %d",icom);
 AddEvent(szmsg);
}
#endif

void UpdateComPortDialog(void)
{
 char szmsg[STRMAX];
 SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_NOPARITY),BM_SETCHECK,Parity==NOPARITY,0);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_EVENPARITY),BM_SETCHECK,Parity==EVENPARITY,0);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_ODDPARITY),BM_SETCHECK,Parity==ODDPARITY,0);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_COM1),BM_SETCHECK,icom==1?1:0,0);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_COM2),BM_SETCHECK,icom==2?1:0,0);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_COM3),BM_SETCHECK,icom==3?1:0,0);
	SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_RADIO_COM4),BM_SETCHECK,icom==4?1:0,0);
 sprintf(szmsg,"%d",BaudRate);
 SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_BAUD_RATE,szmsg);
 sprintf(szmsg,"%d",ByteSize);
 SetDlgItemText(hMDlgComPortMonitor,IDC_EDIT_BYTE_SIZE,szmsg);
 SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_CHECK_USE_EXISTING),BM_SETCHECK,(WPARAM)(use_existing_settings?1:0),0);
}

BOOL CALLBACK ComPortMonitorProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
 switch (message)
 {
  case WM_INITDIALOG :
  {
   hMDlgComPortMonitor=hDlg;
   _beginthread(MonitorComPort,0,NULL);
   UpdateComPortDialog();
   start_up=0;
   return TRUE ;
  }
  case WM_DESTROY:
   break;
  case WM_COMMAND :
   {
    char redo=0;
    if(HIWORD(wParam)==BN_CLICKED)
    switch(LOWORD(wParam))
    {
    case IDCANCEL :
     EndDialog (hDlg, 0) ;
     return TRUE ;
     break ;
    case IDC_CHECK_USE_EXISTING:
     use_existing_settings=use_existing_settings?0:1;
	  	 SendMessage(GetDlgItem(hMDlgComPortMonitor,IDC_CHECK_USE_EXISTING),BM_SETCHECK,(WPARAM)(use_existing_settings?1:0),0);
     redo=1;
     break;
    case IDC_RADIO_NOPARITY:
    case IDC_RADIO_EVENPARITY:
    case IDC_RADIO_ODDPARITY:
     switch(LOWORD(wParam))
     {
     case IDC_RADIO_NOPARITY:Parity=NOPARITY;break;
     case IDC_RADIO_EVENPARITY:Parity=EVENPARITY;break;
     case IDC_RADIO_ODDPARITY:Parity=ODDPARITY;break;
     }
     UpdateComPortDialog();
     redo=1;
     break;
    case IDC_RADIO_COM1:
    case IDC_RADIO_COM2:
    case IDC_RADIO_COM3:
    case IDC_RADIO_COM4:
     switch(LOWORD(wParam))
     {
     case IDC_RADIO_COM1:icom=1;break;
     case IDC_RADIO_COM2:icom=2;break;
     case IDC_RADIO_COM3:icom=3;break;
     case IDC_RADIO_COM4:icom=4;break;
     }
     UpdateComPortDialog();
     redo=1;
     break;
    }
    switch(LOWORD(wParam))
    {
     case IDC_EDIT_BAUD_RATE:
     {
      char sz[STRMAX];
      GetDlgItemText(hMDlgComPortMonitor,LOWORD(wParam),sz,STRMAX);
      if(BaudRate!=atoi(sz))
      {
       BaudRate=atoi(sz);
       redo=1;
      }
      break;
     }
     case IDC_EDIT_BYTE_SIZE:
     {
      char sz[STRMAX];
      GetDlgItemText(hMDlgComPortMonitor,LOWORD(wParam),sz,STRMAX);
      if(ByteSize!=atoi(sz))
      {
       ByteSize=atoi(sz);
       redo=1;
      }
      break;
     }
    }
    if(!start_up)
    if(redo)
    {
     _beginthread(MonitorComPort,0,NULL);
    }
   }
 }
 return FALSE ;
}

int WINAPI WinMain (HINSTANCE hInstanceIs, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
 DialogBox(hInstanceIs,TEXT("ComPortMonitor"),0,ComPortMonitorProc) ;
 return 0; 
}

